Attribute VB_Name = "Example_API_Funtions_V6_0_58"

'--------------------
' public declared statements
'--------------------

Public ShowORHideA As Boolean
Public ShowORHideG As Boolean




Sub CreateObject_Circle_Example()

' Create an object/drawing (VBA- replace [] with variables):
'   GTED_Create_Object [OBJECT], [RANGE], [Z-ENABLED-Y/N], [RELATIVE-Y/N], [LAYER#]
'
' Variables for each are listed below
' Object = "" 'String: Type in object type. Options include:
'   "R" [rectangle],
'   "r" [rounded rectangle],
'   "L" [line],
'   "P" [2 points],
'   "p" [1 point],
'   "C" [circle],
'   "A" [arc],
'   "T" [text]
'   "l" (lower case L) [Line and Point]
'
' Range = "" 'String: Type in the range of the X1 Y1 Z1 X2 Y2 Z2 data.
''Example: "A1:F1"
'
' z Enabled = 2
'   This tells Excel Draw if Z values are enabled.
'   Options are)
'       0 = False
'       1 = True
'       2 = Excel Draw selected tab option
'
' Relative = 2
'   This tells Excel Draw if values are relative.
'   Options are)
'       0 = Absolute
'       1 = Relative
'       2 = Excel Draw selected tab option
'
' Layer = 0
' This option selects which layer the object needs to be created on
'
'
'

    'Randomly generates circle data - Non Z
    ThisWorkbook.ActiveSheet.Range("A1").value = WorksheetFunction.RandBetween(1, 9)
    ThisWorkbook.ActiveSheet.Range("B1").value = WorksheetFunction.RandBetween(1, 9)
    ThisWorkbook.ActiveSheet.Range("C1").value = WorksheetFunction.RandBetween(1, 9)
    
    'Generate Defaults
    GTED_Generate_Defaults
    
    'Creates circle object
    GTED_Create_Object "C", "A1:C1", 0, 0, 1
    
    'Set Pan
    GTED_Set_Pan 0, 0
    
    'Generate Graph
    GTED_Generate_Graph
    
End Sub

Sub RotationExample()

'rotations require the input of two integers ranging from 0 to 360
'for X and Y rotations

    'sets the pan to be centered
    GTED_Set_Pan 0, 0
    
    'loop for rotations
    For i = 0 To 360 Step 45
        DoEvents
        'sets rotations
        GTED_Set_Rotations 45 + CInt(i), 180, CInt(i)
        'generates graph
        GTED_Generate_Graph
    Next
    
End Sub

Sub ZoomExample()
'zoom requires a graph be made and an integer ranging form 0 to 1000
'0 being the most zoomed out point, 1000 being the max zoomed in point.
'
'by default, Excel Draw generates a zoom between 50-200, depending on
'the generated graphed objects.

    Dim n As Integer
    
    'generates graph defaults so no errors occur
    'GTED_Generate_Defaults
    'sets pan so we are centered
    GTED_Set_Pan 0, 0
    
    'gets the current zoom to reset later
    Dim CZ As Integer
    CZ = GTED_Get_Zoom
    
    
    For i = 1 To 10
        DoEvents
        n = i * 1
        'sets soom going up
        GTED_Set_Zoom n
        'generates graph
        GTED_Generate_Graph
    Next
    
    For i = 1 To 9
        DoEvents
        n = 10 - (i * 1)
        'sets soom going down
        GTED_Set_Zoom n
        'generates graph
        GTED_Generate_Graph
    Next

    'set back to previous value
    GTED_Set_Zoom CZ
    'generates graph
    GTED_Generate_Graph
    

End Sub


Sub GetCurrentZoomExample()

'this gets the current zoom for the chart currently graphed
'requires graph already be made

    Dim CZ As Integer
    CZ = GTED_Get_Zoom
    
    MsgBox (CZ)

End Sub

Sub GetGraphInformationExample()

'Requires a graph already be made
    Dim Str As String
    Str = "Rotation X: " & GTED_Get_Rotation_X & vbNewLine & _
            "Rotation Y: " & GTED_Get_Rotation_Y & vbNewLine & _
            "Rotation Z: " & GTED_Get_Rotation_Z & vbNewLine & _
            vbNewLine & _
            "Pan X: " & GTED_Get_Pan_X & vbNewLine & _
            "Pan Y: " & GTED_Get_Pan_Y
            
    MsgBox (Str)
    
End Sub


Sub MoveGraphExample()

    'Setting the Min and Max values for random generation
    Dim Mn As Integer
    Mn = 100
    Dim Mx As Integer
    Mx = 500

    'declaring values
    Dim T As Integer
    Dim L As Integer
    Dim H As Integer
    Dim W As Integer
    
    'sets a random size for graph
    Dim s As Integer
    s = WorksheetFunction.RandBetween(Mn, Mx)
    
    'sets a random location for graph
    T = WorksheetFunction.RandBetween(Mn, Mx)
    L = WorksheetFunction.RandBetween(Mn, Mx)
    
    'makes graph square
    H = s
    W = s
    
    'sets the values
    GTED_Set_GraphLocation T, L, H, W
    
    'generates graph
    GTED_Generate_Graph
    
End Sub


Sub ShowAxisArmsExample()
'a true or false statement that either shows or hides axes arms

    If ShowORHideA = False Then ShowORHideA = True
    'shows or hides axis arms  ---- {ShowORHideA is declared at bottom of example VBA}
    GTED_Graph_Axis_Arms (ShowORHideA)
    'generates graph
    GTED_Generate_Graph
    
End Sub

Sub ShowAxisGroundExample()
'a true or false statement that either shows or hides axes arms

    If ShowORHideG = False Then ShowORHideG = True
    'shows or hides axis arms  ---- {ShowORHideA is declared at bottom of example VBA}
    GTED_Graph_Ground_Layer (ShowORHideG)
    'generates graph
    GTED_Generate_Graph
    
End Sub





Sub ExportDrawingExample()
'requires a drawing already be made

    'File Export Location - this is optional string, but helpful
    Dim Path As String
    Path = "C:\test"
    
    'The file name - also optional string, but helpful
    Dim FileName As String
    FileName = "Test DXF Export"
    
    'The file type - also optional string - can be DXF, PDF, TXT or CSV
    Dim FileType As String
    FileType = "DXF"
    
    'Set the boolean to overwrite exiting file
    Dim Overwrite As Boolean
    Overwrite = False
    
    'Set the boolean to open once exported
    Dim OpenAfter As Boolean
    OpenAfter = True
    
    'Generate Graph
    GTED_Generate_Graph
    
    ExcelDrawExportFileMacroAPI Path, FileName, FileType, Overwrite, OpenAfter
       
    
End Sub





