Attribute VB_Name = "Example_API_Funtions_V6_2_47"

'--------------------
' public declared statements
'--------------------

Public ShowORHideA As Boolean
Public ShowORHideG As Boolean




Sub CreateObject_Circle_Example()

' Create an object/drawing (VBA- replace [] with variables):
'   GTED_Create_Object [OBJECT], [RANGE], [Z-ENABLED-Y/N], [RELATIVE-Y/N], [LAYER#]
'
' Variables for each are listed below
' Object = "" 'String: Type in object type. Options include:
'   "R" [rectangle],
'   "r" [rounded rectangle],
'   "L" [line],
'   "P" [2 points],
'   "p" [1 point],
'   "C" [circle],
'   "A" [arc],
'   "T" [text]
'   "l" (lower case L) [Line and Point]
'
' Range = "" 'String: Type in the range of the X1 Y1 Z1 X2 Y2 Z2 data.
''Example: "A1:F1"
'
' z Enabled = 2
'   This tells Excel Draw if Z values are enabled.
'   Options are)
'       0 = False
'       1 = True
'       2 = Excel Draw selected tab option
'
' Relative = 2
'   This tells Excel Draw if values are relative.
'   Options are)
'       0 = Absolute
'       1 = Relative
'       2 = Excel Draw selected tab option
'
' Layer = 0
' This option selects which layer the object needs to be created on
' layers can range from 0 to 9
'
'
'

    'Randomly generates circle data - Non Z
    ThisWorkbook.ActiveSheet.Range("A1").Value = WorksheetFunction.RandBetween(1, 9)
    ThisWorkbook.ActiveSheet.Range("B1").Value = WorksheetFunction.RandBetween(1, 9)
    ThisWorkbook.ActiveSheet.Range("C1").Value = WorksheetFunction.RandBetween(1, 9)
    
    'Generate Defaults
    GTED_Generate_Defaults
    
    'Creates circle object
    GTED_Create_Object "C", "A1:C1", 0, 0, 1
    
    'Set Pan
    GTED_Set_Pan 0, 0
    
    'Generate Graph
    GTED_Generate_Graph
    
End Sub


Sub Cells_to_CAD_Example()
    'This will convert formatted cells with boarders to
    'create drawings, mostly used for creating tables
    
    'The list of variables you will need to specify are listed here:
    Dim CC As Boolean       'Custom Colors in Text - This will take the text color from the cell
    Dim CFS As Double       'Custom Font Size - 0 for font size present in cell, any other number for custom size of that number
    Dim SOWFS As Boolean    'Scale Objects With Font Size - this scales objects with font size to keep proportions
    Dim SX As Double        'Starting X point of converted range - This is LEFT SIDE of the selected cells range
    Dim SY As Double        'Starting Y point of converted range - This is TOP LEFT of the selected cells range
    Dim SZ As Double        'Starting Z poing of converted range - This is how VERTICAL the selected cells will be when converted
    Dim WS As Worksheet     'Worksheet you want to pull the data from
    Dim RC As String        'Range of cells you want to convert in STRING format (example: "A1:C7")
    
    ' Example of starting point:
    '
    '     --------------> +X
    '    |   o_____________
    '    |   |____|____|___|
    '    |   |____|____|___|
    '    |   |____|____|___|
    '    |   |____|____|___|
    '    V
    '   -Y
    '
    '   In the image above, 'o' represents
    '   the top left of selected range. This
    '   is the starting point. This 'o' can
    '   be customized with the Starting X, Y, Z
    '   values declared above. By default it is
    '   set to 0, 0, 0
    '
    
    
    'Specify if you want to use the colors in the cell
    CC = True
    
    'Specify custom font size - 0 being whatever the size is in the cell
    CFS = 0
    
    'Specify if you want objects scaped with fonts, which you do to keep things scaled correctly
    SOWFS = True
    
    'Starting point - refer to image above
    SX = 0
    SY = 0
    SZ = 0
    
    'Set the worksheet you want to pull data from
    Set WS = ThisWorkbook.Sheets("Sheet1")
    
    'Range you want to convert.
    'Should have text, boarders, ect.
    'merged cells are also converted.
    'If there are no boarders, there will be no lines/rectangles.
    RC = "A1:C1"
    
    
    '---------------------
    ' clearing and creating
    ' temp values for sample
    '---------------------
    
    'backing up cells
    Dim val1 As String
    Dim val2 As String
    Dim val3 As String
    val1 = WS.Range("A1").Formula
    val2 = WS.Range("B1").Formula
    val3 = WS.Range("C1").Formula
    
    'clearing cells
    WS.Range(RC).Value = ""
    
    'merge cells
    WS.Range(RC).Merge
    
    'input test value with color
    'and boarders
    WS.Range("A1").Value = "TEST"
    WS.Range(RC).Select
    With Selection.Font
        .Color = -16776961
        .TintAndShade = 0
    End With
    Selection.Borders(xlDiagonalDown).LineStyle = xlNone
    Selection.Borders(xlDiagonalUp).LineStyle = xlNone
    With Selection.Borders(xlEdgeLeft)
        .LineStyle = xlContinuous
        .ColorIndex = 0
        .TintAndShade = 0
        .Weight = xlThin
    End With
    With Selection.Borders(xlEdgeTop)
        .LineStyle = xlContinuous
        .ColorIndex = 0
        .TintAndShade = 0
        .Weight = xlThin
    End With
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .ColorIndex = 0
        .TintAndShade = 0
        .Weight = xlThin
    End With
    With Selection.Borders(xlEdgeRight)
        .LineStyle = xlContinuous
        .ColorIndex = 0
        .TintAndShade = 0
        .Weight = xlThin
    End With
    With Selection.Borders(xlInsideVertical)
        .LineStyle = xlContinuous
        .ColorIndex = 0
        .TintAndShade = 0
        .Weight = xlThin
    End With
    With Selection.Borders(xlInsideHorizontal)
        .LineStyle = xlContinuous
        .ColorIndex = 0
        .TintAndShade = 0
        .Weight = xlThin
    End With
    
    
    
    'now we generate the drawing
    GTED_Cells_to_CAD CC, CFS, SOWFS, SX, SY, SZ, WS, RC
    
    
    'now put things back
    Range(RC).Value = ""
    Selection.Borders(xlDiagonalDown).LineStyle = xlNone
    Selection.Borders(xlDiagonalUp).LineStyle = xlNone
    Selection.Borders(xlEdgeLeft).LineStyle = xlNone
    Selection.Borders(xlEdgeTop).LineStyle = xlNone
    Selection.Borders(xlEdgeBottom).LineStyle = xlNone
    Selection.Borders(xlEdgeRight).LineStyle = xlNone
    Selection.Borders(xlInsideVertical).LineStyle = xlNone
    Selection.Borders(xlInsideHorizontal).LineStyle = xlNone
    With Selection.Font
        .ColorIndex = xlAutomatic
        .TintAndShade = 0
    End With
    Range(RC).UnMerge
    
    Range("A1").Value = val1
    Range("B1").Value = val2
    Range("C1").Value = val3
    
    
End Sub

Sub RotationExample()

'rotations require the input of two integers ranging from 0 to 360
'for X and Y rotations

    'sets the pan to be centered
    GTED_Set_Pan 0, 0
    
    'loop for rotations
    For i = 0 To 360 Step 45
        DoEvents
        'sets rotations
        GTED_Set_Rotations 45 + CInt(i), 180, CInt(i)
        'generates graph
        GTED_Generate_Graph
    Next
    
End Sub

Sub ZoomExample()
'zoom requires a graph be made and an integer ranging form 0 to 1000
'0 being the most zoomed out point, 1000 being the max zoomed in point.
'
'by default, Excel Draw generates a zoom between 50-200, depending on
'the generated graphed objects.

    Dim n As Integer
    
    'generates graph defaults so no errors occur
    'GTED_Generate_Defaults
    'sets pan so we are centered
    GTED_Set_Pan 0, 0
    
    'gets the current zoom to reset later
    Dim CZ As Integer
    CZ = GTED_Get_Zoom
    
    
    For i = 1 To 10
        DoEvents
        n = i * 1
        'sets soom going up
        GTED_Set_Zoom n
        'generates graph
        GTED_Generate_Graph
    Next
    
    For i = 1 To 9
        DoEvents
        n = 10 - (i * 1)
        'sets soom going down
        GTED_Set_Zoom n
        'generates graph
        GTED_Generate_Graph
    Next

    'set back to previous value
    GTED_Set_Zoom CZ
    'generates graph
    GTED_Generate_Graph
    

End Sub


Sub GetCurrentZoomExample()

'this gets the current zoom for the chart currently graphed
'requires graph already be made

    Dim CZ As Integer
    CZ = GTED_Get_Zoom
    
    MsgBox (CZ)

End Sub

Sub GetGraphInformationExample()

'Requires a graph already be made
    Dim Str As String
    Str = "Rotation X: " & GTED_Get_Rotation_X & vbNewLine & _
            "Rotation Y: " & GTED_Get_Rotation_Y & vbNewLine & _
            "Rotation Z: " & GTED_Get_Rotation_Z & vbNewLine & _
            vbNewLine & _
            "Pan X: " & GTED_Get_Pan_X & vbNewLine & _
            "Pan Y: " & GTED_Get_Pan_Y
            
    MsgBox (Str)
    
End Sub


Sub MoveGraphExample()

    'Setting the Min and Max values for random generation
    Dim Mn As Integer
    Mn = 100
    Dim Mx As Integer
    Mx = 500

    'declaring values
    Dim T As Integer
    Dim L As Integer
    Dim H As Integer
    Dim W As Integer
    
    'sets a random size for graph
    Dim s As Integer
    s = WorksheetFunction.RandBetween(Mn, Mx)
    
    'sets a random location for graph
    T = WorksheetFunction.RandBetween(Mn, Mx)
    L = WorksheetFunction.RandBetween(Mn, Mx)
    
    'makes graph square
    H = s
    W = s
    
    'sets the values
    GTED_Set_GraphLocation T, L, H, W
    
    'generates graph
    GTED_Generate_Graph
    
End Sub


Sub ShowAxisArmsExample()
'a true or false statement that either shows or hides axes arms

    If ShowORHideA = False Then ShowORHideA = True
    'shows or hides axis arms  ---- {ShowORHideA is declared at bottom of example VBA}
    GTED_Graph_Axis_Arms (ShowORHideA)
    'generates graph
    GTED_Generate_Graph
    
End Sub

Sub ShowAxisGroundExample()
'a true or false statement that either shows or hides axes arms

    If ShowORHideG = False Then ShowORHideG = True
    'shows or hides axis arms  ---- {ShowORHideA is declared at bottom of example VBA}
    GTED_Graph_Ground_Layer (ShowORHideG)
    'generates graph
    GTED_Generate_Graph
    
End Sub





Sub ExportDrawingExample()
'requires a drawing already be made

    'File Export Location
    Dim Path As String
    Path = "C:\test"
    
    'The file name
    Dim FileName As String
    FileName = "Test DXF Export"
    
    'The file type -  can be DXF, PDF, TXT or CSV
    Dim FileType As String
    FileType = "DXF"
    
    'Set the boolean to overwrite exiting file
    Dim Overwrite As Boolean
    Overwrite = False
    
    'Set the boolean to open once exported
    Dim OpenAfter As Boolean
    OpenAfter = True
    
    'Set to have LayerColors boolean
    Dim LayerColoring As Boolean
    LayerColoring = False
    
    'Set to have text overwrite existing colors and be custom
    Dim CustomTextColors As Boolean
    CustomTextColors = False
    
    'No graphing option enabled
    GTED_Disable_Graph True
    
    ExcelDrawExportFileMacroAPI Path, FileName, FileType, Overwrite, OpenAfter, LayerColoring, CustomTextColors
       
    
End Sub




Sub GetACIColorFromRGBExample()

    'This will give you the color of AutoCAD Color Index from RGB colors
    
    'start by defining the RGB color
    Dim R As Integer
    Dim G As Integer
    Dim B As Integer
    
    R = 123
    G = 234
    B = 12
    
    'create a variable for the return value
    Dim ACI As Integer
    
    'generate the ACI color, or closest to it
    ACI = GTED_Get_ACI_Color(R, G, B)
    
    'display ACI color
    MsgBox ("Closest ACI match for: " & R & ", " & G & ", " & B & " is the ACI of " & ACI)
    
End Sub


Sub GetRGBColorFromACIExample()
    'This will give you the RGB color for an AutoCAD Color Index
    'start by defining the ACI color
    Dim ACI As Integer
    ACI = 34
    
    'create a variable for the return value - needs to be variant
    Dim RGB As Variant
    
    'generate the RGB color based on ACI
    RGB = GTED_Get_RGB_Color(ACI)
    
    'display RGB in some way, or store it
    MsgBox ("The ACI of " & CStr(ACI) & " has an RGB index of " & RGB(0) & ", " & RGB(1) & ", " & RGB(2))

End Sub

Sub SetLayerColor_and_ObjectColor_Example()

    'Excel Draw changes layer colors based on Object Colors.
    
    '------------------------------------------------------------------------
    
    'Each Object has its own unique color.
    'This results in a total option of 8 colors.
    'Line_Rectangle_Circle_Point_Arc_Distance_Text_Background
    
    'Using this you can set each layer to have the color of a specific object
    
    '------------------------------------------------------------------------
    
    'Declare your Layer you want to use
    Dim Lyr As Integer
    Lyr = 0     '0-9 for layers and 10 for background
    
    
    'Declare your object you want to change color of
    Dim OB As String
    OB = "Line" 'Case sensitive - objects can be called as such:
                'Line Rectangle Circle Point Arc Distance Text Background
                
    'Decide on your color
    Dim R As Integer
    Dim G As Integer
    Dim B As Integer
    
    R = 12
    G = 23
    B = 34
    
    '-----------------------------------------------
    '  ---- OPTIONAL USE OF ACI TO RGB -----
    'You can also use the examples above to create
    'these colors in ACI for 100% CAD compatability
        
    Dim ACI As Integer
    ACI = 14
    
    Dim RGB As Variant
    RGB = GTED_Get_RGB_Color(ACI)
    
    R = RGB(0)
    G = RGB(1)
    B = RGB(2)
    
    '  ---- OPTIONAL USE OF ACI TO RGB -----
    '-----------------------------------------------
    
    
    'Now that we have the layer, the object, and the color
    'lets start by setting the object color
    
    'this sets the object color
    GTED_Set_Object_Color OB, R, G, B
    
    'now we will set the layer to the object color
    'this sets the layer color to match that of the object
    GTED_Set_Layer_Object Lyr, OB
    
    
    'Generate Graph
    GTED_Generate_Graph
    
    
    
End Sub


